<template>
  <q-list>
    <!-- Current Rotation -->
    <q-item-label header>
      <translate>Crop Rotations</translate>
    </q-item-label>
    <q-expansion-item
      v-for="(rotation, index) in $store.state.fertilizationPlan.parameters.current_rotations"
      :key="'rotation-' + index"
      expand-separator
      :label="`${(index + 1)}. ${rotation.visione_profile.profile_name}${rotation.visione_profile.profile_option ? ' ' + rotation.visione_profile.profile_option : ''}`"
      expand-icon="las la-angle-down"
      expanded-icon="las la-angle-up"
      dense
    >
      <q-list>
        <!-- Rotation - cover crop (first rotation only) -->
        <q-item
          v-if="rotation.is_green_manure_cover_crop != null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              Is used as cover crop ?
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ rotation.is_green_manure_cover_crop ? $gettext('Yes') : $gettext('No') }}
          </q-item-section>
        </q-item>
        <!-- Rotation - Cycles -->
        <q-item
          dense
          v-if="rotation.visione_profile.profile_group === PROFILE_GROUPS.ORTICOLE"
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              Number of crop cycles
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ rotation.crop_cycles }}
          </q-item-section>
        </q-item>
        <!-- Rotation - yield -->
        <q-item dense>
          <q-item-label
            header
            class="col-5"
          >
            <translate>Estimated crop yield</translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ rotation.crop_yield_per_cycle }}{{ $pgettext('ton per hectare', 't/ha') }}
          </q-item-section>
        </q-item>
        <!-- Rotation - humidity -->
        <q-item dense>
          <q-item-label
            header
            class="col-5"
          >
            <translate>Crop yield humidity</translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ rotation.crop_yield_humidity_per_cycle }}%
          </q-item-section>
        </q-item>
        <!-- Rotation - residues -->
        <q-item dense>
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              Are residues buried ?
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ rotation.residues_are_buried ? $gettext('Yes') : $gettext('No') }}
          </q-item-section>
        </q-item>
        <!-- Rotation - Fertilizations -->
        <template v-if="rotation.fertilizations && rotation.fertilizations.length">
          <q-item dense>
            <q-item-label header>
              <translate>Effluents / Fertilizers</translate>
            </q-item-label>
          </q-item>
          <q-item
            v-for="fertilization in rotation.fertilizations"
            :key="'roation-' + index + '-fertilization-' + fertilization.organic_fertilizer.id"
            dense
          >
            <q-item-section avatar>
              <q-icon
                color="grey"
                name="las la-minus"
              />
            </q-item-section>
            <q-item-section>
              <q-item-label>{{ fertilization.organic_fertilizer.name }}</q-item-label>
              <q-item-label
                caption
                lines="2"
              >
                {{ fertilization.organic_fertilizer_efficiency.label }}
              </q-item-label>
              <q-item-label
                caption
              >
                <span class="q-mr-sm">
                  N: {{ fertilization.organic_fertilizer.n }}%
                </span>
                <span class="q-mr-sm">
                  P<sub>2</sub>O<sub>5</sub>: {{ fertilization.organic_fertilizer.p2o5 }}%
                </span>
                <span>
                  K<sub>2</sub>O: {{ fertilization.organic_fertilizer.k2o }}%
                </span>
              </q-item-label>
            </q-item-section>
            <q-item-section
              side
              top
              class="text-black"
            >
              <q-item-label>{{ fertilization.dose }}{{ $pgettext('ton per hectare', 't/ha') }}</q-item-label>
            </q-item-section>
          </q-item>
        </template>
      </q-list>
    </q-expansion-item>
    <!-- Previous Campaign -->
    <q-item-label header>
      <translate>Previous campaign</translate>
    </q-item-label>
    <q-expansion-item
      expand-separator
      :label="`${$store.state.fertilizationPlan.parameters.previous_rotation.visione_profile.profile_name}${$store.state.fertilizationPlan.parameters.previous_rotation.visione_profile.profile_option ? ' ' + $store.state.fertilizationPlan.parameters.previous_rotation.visione_profile.profile_option : ''}`"
      expand-icon="las la-angle-down"
      expanded-icon="las la-angle-up"
      dense
    >
      <q-list>
        <!-- Residues -->
        <q-item dense>
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              Are residues buried ?
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ $store.state.fertilizationPlan.parameters.previous_rotation.residues_are_buried ? $gettext('Yes') : $gettext('No') }}
          </q-item-section>
        </q-item>
        <template v-if="$store.state.fertilizationPlan.parameters.previous_rotation.residues_are_buried">
          <!-- Yield -->
          <q-item dense>
            <q-item-label
              header
              class="col-5"
            >
              <translate>Estimated crop yield</translate>
            </q-item-label>
            <q-item-section class="col-7">
              {{ $store.state.fertilizationPlan.parameters.previous_rotation.crop_yield_per_cycle + $pgettext('ton per hectare', 't/ha') }}
            </q-item-section>
          </q-item>
          <!-- Humidity -->
          <q-item dense>
            <q-item-label
              header
              class="col-5"
            >
              <translate>Crop yield humidity</translate>
            </q-item-label>
            <q-item-section class="col-7">
              {{ $store.state.fertilizationPlan.parameters.previous_rotation.crop_yield_humidity_per_cycle + '%' }}
            </q-item-section>
          </q-item>
        </template>
        <!-- Manure distribution -->
        <q-item dense>
          <q-item-label
            header
            class="col-5"
          >
            <translate>Manure / Amender distribution</translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ $store.state.fertilizationPlan.parameters.previous_rotation.manure_distribution.label }}
          </q-item-section>
        </q-item>
        <!-- Manure / compost fertilization -->
        <q-item
          v-if="$store.state.fertilizationPlan.parameters.previous_rotation.fertilization"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate>Manure / Compost fertilizer</translate>
          </q-item-label>
          <q-item-section class="col-5">
            <q-item-label>
              {{ $store.state.fertilizationPlan.parameters.previous_rotation.fertilization.organic_fertilizer.name }}
            </q-item-label>
            <q-item-label>{{ $store.state.fertilizationPlan.parameters.previous_rotation.fertilization.dose + $pgettext('ton per hectare', 't/ha') }}</q-item-label>
            <q-item-label
              caption
            >
              <span class="q-mr-sm">
                N: {{ $store.state.fertilizationPlan.parameters.previous_rotation.fertilization.organic_fertilizer.n }}%
              </span>
              <span class="q-mr-sm">
                P<sub>2</sub>O<sub>5</sub>: {{ $store.state.fertilizationPlan.parameters.previous_rotation.fertilization.organic_fertilizer.p2o5 }}%
              </span>
              <span>
                K<sub>2</sub>O: {{ $store.state.fertilizationPlan.parameters.previous_rotation.fertilization.organic_fertilizer.k2o }}%
              </span>
            </q-item-label>
          </q-item-section>
        </q-item>
      </q-list>
    </q-expansion-item>
    <!-- Soil -->
    <q-item-label header>
      <translate>Soil</translate>
    </q-item-label>
    <q-expansion-item
      v-for="soilObject in [getSoilObject(plot.id)]"
      :key="'plot-' + soilObject.plot.id + '-soil-object'"
      expand-separator
      :label="soilResume($store.state.fertilizationPlan.parameters.soil_objects.find(so => so.plot.id === plot.id))"
      expand-icon="las la-angle-down"
      expanded-icon="las la-angle-up"
      dense
    >
      <q-list>
        <!-- Soil - Texture -->
        <q-item
          v-if="soilObject.observations.texture.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              Soil texture
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.texture.value.label }}
          </q-item-section>
        </q-item>
        <!-- Soil - Sand -->
        <q-item
          v-if="soilObject.observations.sand_pct.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              Sand
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.sand_pct.value }} {{ soilProperties.find(sp => sp.id === 'sand_pct').unit_of_measure.symbol }}
          </q-item-section>
        </q-item>
        <!-- Soil - Clay -->
        <q-item
          v-if="soilObject.observations.clay_pct.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              Clay
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.clay_pct.value }} {{ soilProperties.find(sp => sp.id === 'clay_pct').unit_of_measure.symbol }}
          </q-item-section>
        </q-item>
        <!-- Soil - is limy -->
        <q-item
          v-if="soilObject.observations.is_limy.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate translate-context="The soil (is the soil limy ?)">
              Is limy ?
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.is_limy.value ? $gettext('Yes') : $gettext('No') }}
          </q-item-section>
        </q-item>
        <!-- Soil - pH -->
        <q-item
          v-if="soilObject.observations.ph.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              pH
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.ph.value }}
          </q-item-section>
        </q-item>
        <!-- Soil - P (phosphorus) -->
        <q-item
          v-if="soilObject.observations.phosphorus.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate translate-context="Phosphorus available as P Olsen in soil">
              P Olsen
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.phosphorus.value }} {{ soilProperties.find(sp => sp.id === 'phosphorus').unit_of_measure.symbol }}
          </q-item-section>
        </q-item>
        <!-- Soil - K (potassium) -->
        <q-item
          v-if="soilObject.observations.potassium.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate translate-context="Potassium available as exchangeable K in soil. Exchangeable K is the name of the chemical extraction method. In Italian: \&quot;K scambiabile&quot;">
              Exchangeable K
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.potassium.value }} {{ soilProperties.find(sp => sp.id === 'potassium').unit_of_measure.symbol }}
          </q-item-section>
        </q-item>
        <!-- Soil - Organic matter -->
        <q-item
          v-if="soilObject.observations.organic_matter_pct.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate>
              Organic matter
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.organic_matter_pct.value }} {{ soilProperties.find(sp => sp.id === 'organic_matter_pct').unit_of_measure.symbol }}
          </q-item-section>
        </q-item>
        <!-- Soil - C/N -->
        <q-item
          v-if="soilObject.observations.c_n.value !== null"
          dense
        >
          <q-item-label
            header
            class="col-5"
          >
            <translate translate-context="Ratio C/N (Carbon over Nitrogen)">
              C/N
            </translate>
          </q-item-label>
          <q-item-section class="col-7">
            {{ soilObject.observations.c_n.value }}
          </q-item-section>
        </q-item>
      </q-list>
    </q-expansion-item>
  </q-list>
</template>

<script>
import VisioneMixins, { PROFILE_GROUPS } from 'src/pages/fieldbook/fertilization/algorithms/visione/mixins/VisioneMixins'

export default {
  name: 'VisioneComputeNonTreeCrop',
  mixins: [VisioneMixins],
  props: {
    plot: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      PROFILE_GROUPS
    }
  },
  methods: {
    getSoilObject (plotId) {
      return this.$store.state.fertilizationPlan.parameters.soil_objects.find(so => so.plot.id === plotId)
    },
    soilResume (soilObject) {
      const chars = []
      if (soilObject.observations.texture.value !== null) {
        chars.push(soilObject.observations.texture.value.label)
      }
      if (soilObject.observations.sand_pct.value !== null) {
        chars.push(this.$gettext('Sand') + ': ' + soilObject.observations.sand_pct.value + this.soilProperties.find(sp => sp.id === 'sand_pct').unit_of_measure.symbol)
      }
      if (soilObject.observations.clay_pct.value !== null) {
        chars.push(this.$gettext('Clay') + ': ' + soilObject.observations.clay_pct.value + this.soilProperties.find(sp => sp.id === 'clay_pct').unit_of_measure.symbol)
      }
      if (soilObject.observations.is_limy.value !== null) {
        const s = soilObject.observations.is_limy.value ? this.$gettext('Yes') : this.$gettext('No')
        chars.push(this.$pgettext('The soil (is the soil limy ?)', 'Is limy ?') + ' ' + s)
      }
      if (soilObject.observations.ph.value !== null) {
        chars.push(this.$gettext('pH') + ': ' + soilObject.observations.ph.value)
      }
      if (soilObject.observations.phosphorus.value !== null) {
        chars.push(this.$pgettext('Phosphorus available as P Olsen in soil', 'P Olsen') + ': ' + soilObject.observations.phosphorus.value + this.soilProperties.find(sp => sp.id === 'phosphorus').unit_of_measure.symbol)
      }
      if (soilObject.observations.potassium.value !== null) {
        chars.push(
          this.$pgettext(
            'Potassium available as exchangeable K in soil. Exchangeable K is the name of the chemical extraction method. In Italian: "K scambiabile"',
            'Exchangeable K'
          ) + ': ' + soilObject.observations.potassium.value + this.soilProperties.find(sp => sp.id === 'potassium').unit_of_measure.symbol)
      }
      if (soilObject.observations.organic_matter_pct.value !== null) {
        chars.push(this.$gettext('Organic matter') + ': ' + soilObject.observations.organic_matter_pct.value + this.soilProperties.find(sp => sp.id === 'organic_matter_pct').unit_of_measure.symbol)
      }
      if (soilObject.observations.c_n.value !== null) {
        chars.push(this.$pgettext('Ratio C/N (Carbon over Nitrogen)', 'C/N') + ': ' + soilObject.observations.c_n.value)
      }
      return chars.join(', ')
    }
  }
}
</script>
